<?php
/* ----------------------------------------------------------------------------
  初期設定
  
  $URL    : FileMaker Server(FileMaker Cloud for AWS)のドメイン名(SSL)
  $id     : FileMaker Data API でのアクセスにチェックしたアカウント名
  $pw     : FileMaker Data API でのアクセスにチェックしたパスワード
  $DB     : 接続するデータソース名
  $LAYOUT : 接続するレイアウト名
  $APIVER : 接続利用するAPIのバージョン(通常変更しない)
  
  ---------------------------------------------------------------------------- */

  $URL     = 'https://接続先ドメイン名'; // 例) https://filemaker.workspace.co.jp etc...
  $id      = 'アカウント名';
  $pw      = 'パスワード';
  $DB      = 'データベース名';
  $LAYOUT  = 'アクセスするレイアウト名';
  $APIVER  = 'vLatest';
?>
<?php
/* ----------------------------------------------------------------------------
  以下は必要に応じて変更
  ---------------------------------------------------------------------------- */

// ログイン情報の Base64 エンコード処理
  $AUTH = base64_encode($id . ':' . $pw);

// XSS 処理
  $q1   = htmlspecialchars(implode(' ',$_POST["q1"]),      ENT_QUOTES, 'UTF-8');
  $q2   = htmlspecialchars($_POST["q2"],      ENT_QUOTES, 'UTF-8');
  $q3   = htmlspecialchars($_POST["q3"],      ENT_QUOTES, 'UTF-8');
  $q4   = htmlspecialchars($_POST["q4"],      ENT_QUOTES, 'UTF-8');
  $name = htmlspecialchars($_POST["name"],    ENT_QUOTES, 'UTF-8');

// ポストする値を JSON フォーマット
  $POSTFIELDS  = "{ \"fieldData\":";
  $POSTFIELDS .= " {"; 
  $POSTFIELDS .= "   \"q1\":\"" . $q1 . "\",";
  $POSTFIELDS .= "   \"q2\":\"" . $q2 . "\",";
  $POSTFIELDS .= "   \"q3\":\"" . $q3 . "\",";
  $POSTFIELDS .= "   \"q4\":\"" . $q4 . "\",";
  $POSTFIELDS .= "   \"name\":\"" . $name . "\"";
  $POSTFIELDS .= " }"; 
  $POSTFIELDS .= "}"; 

?>
<?php
/* ----------------------------------------------------------------------------
  ログイン - レコード追加 - ログアウト の処理
  ---------------------------------------------------------------------------- */

// 1. ログイン
  $token = funccurl($URL, 'login', $AUTH, $DB, '', $APIVER,  '', '');


// 2. レコードの追加
  $result = funccurl($URL, 'createrecord', '', $DB, $LAYOUT, $APIVER,  $token, $POSTFIELDS);

// 3. ログアウト
  $result = funccurl($URL, 'logout', '', $DB, '', $APIVER,  $token, '');

?>
<?php

/* ----------------------------------------------------------------------------
  このスクリプトで利用する関数(変更しない)
  ---------------------------------------------------------------------------- */
function funccurl($URL, $type, $AUTH, $DB, $LAYOUT, $APIVER, $TOKEN, $POSTFIELDS){
  
  switch($type){
    case "login";
    $opturl = $URL . "/fmi/data/" . $APIVER . "/databases/" . $DB . "/sessions";
    $method = 'POST';
    $auth   = 'authorization: basic '  . $AUTH;
    $contentlength = 'content-length: 0';
    break;
    case "logout";
    $opturl = $URL . "/fmi/data/" . $APIVER . "/databases/" . $DB . "/sessions/" . $TOKEN;
    $method = 'DELETE';
    $auth   = 'authorization: bearer '  . $TOKEN;
    break;
    case "createrecord";
    $opturl = $URL . "/fmi/data/" . $APIVER . "/databases/" . $DB . "/layouts/" . $LAYOUT . "/records";
    $method = 'POST';
    $auth   = 'authorization: bearer '  . $TOKEN;
    break;
  }
  
  $curl = curl_init();
  curl_setopt_array($curl,
  array(
  CURLOPT_URL => $opturl,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => $method,
  CURLOPT_POSTFIELDS => $POSTFIELDS,
  CURLOPT_HTTPHEADER => array(
  "cache-control: no-cache",
  "content-type: application/json",
  $auth,
  $contentlength
  ),
  )
  );
  
  $response = curl_exec($curl);
  curl_close($curl);

  $response = json_decode($response, true);

  switch($type){
    case "login";         return ($response["response"]["token"]);
    case "createrecord";
    case "logout";        return ($response["messages"][0]["message"]);
  }
}

?>
<?php
/* ----------------------------------------------------------------------------
  以下、完了時に表示するHTML
  ---------------------------------------------------------------------------- */
?>
<html>
  <head>
    <meta name="viewport" content="width=device-width">
    <meta charset="utf-8">
    <title>アンケートへのご回答ありがとうございました</title>
  </head>
  <body>
    アンケートへのご回答ありがとうございました<br>
    [ <a href="./">戻る</a> ]
  </body>
</html>
